/*
 * Principal.java
 *
 * Created on 19/05/2011, 09:44:35
 * License: GPLv3
 */
package jogo;

import java.util.ArrayList;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JDialog;
import javax.swing.JOptionPane;

/**
 *
 * @author Emerson Ribeiro de Mello
 *
 *
 */

public class Cliente extends javax.swing.JFrame {

   private ArrayList<Carta> baralho;
   private int posicialInicialX;// coordenada X onde deve aparecer a 1a. carta
   private int posicialInicialY;// coordenada Y onde deve aparecer a 1a. carta
   private boolean conectado = false;
   private ClienteThread ct;
   private Servidor sr;
   private String ip;
   private String port;
   private String NomeDoJogador;
   private String clID;
   private Carta CartaADV;
   private boolean MinhaVez=false;

   /** Creates new form Principal */
   public Cliente() {
      this.posicialInicialX = 150;
      this.posicialInicialY = 310;
      this.baralho = new ArrayList<Carta>();

      //this.criaBaralho();

      initComponents();
      this.setLocationRelativeTo(null);
      this.jBEmbaralhar.setEnabled(false);
      this.jBTSairRodada.setEnabled(false);
      this.jBTruco.setEnabled(false);
      this.jBVirarCartas.setEnabled(false);
      this.jTFMinhasCartas.setEditable(false);
      this.jTFManilha.setEditable(false);
      this.jTFCartaMesa.setEditable(false);
      this.jBEnviarCarta.setEnabled(false);
      this.jTFCartaAdv.setEditable(false);
      //this.jTFTCartaEnv.setEditable(false);

   }

   /**
    * Cria as cartas e adiciona no baralho
    * Adaptado de:
    * Fred Swartz - February 19, 2007 - Placed in public domain.
    */
   public void criaBaralho( ArrayList<String> b) {
      
      /*String naipe = "oecp";
      String frente = "1234567";*/
      int pos = 0;
      int px = this.posicialInicialX;
      int py = this.posicialInicialY;

     for( int a = 0; a < b.size(); a++ ){
            String caminho = ""+b.get(a) + ".png";
            // true para carta com o verso aparecendo
            // false para aparecer a frente da carta
            Carta ca = new Carta(caminho, false);
            
            if(a==0){
              px = 200;
              py = 310;
              ca.mover(px, py);
            }
            if(a==1){
              px = 300;
              py = 310;
              ca.mover(px, py);
            }
            
            if(a==2){
              px = 400;
              py = 310;
              ca.mover(px, py);
            }
            
            
            if(a==3){
              px =350;
              py =185 ;
              ca.mover(px, py);
            }
            

            this.baralho.add(ca);
            //((Mesa) this.jPMesa).repaint();
         
     } 
      
   }
   
   public void CriaCarta(String s){
   
       int px =200;
       int py = 160;
       String caminho = ""+s + ".png";
       CartaADV  = new Carta(caminho, false);
       CartaADV.mover(px, py);
       this.baralho.add(CartaADV);
        ((Mesa) this.jPMesa).repaint();
        //CartaADV.desenhar(null, jPMesa);
        
   }

   public void  ApagarCarta(){
   
    this.CartaADV.mover(1000, 3000);
    this.CartaADV = null;
   
   }
   
   public void setMinhaVez(boolean a){
   
   this.MinhaVez =a;
   }
   
   public boolean GetMinhaVez(){
   
       
       return this.MinhaVez;
   
   }
   public int getPosicialInicialX() {
      return posicialInicialX;
   }

   public void ClienteHumano() {

           
}


   public int getPosicialInicialY() {
      return posicialInicialY;
   }

   /** This method is called from within the constructor to
    * initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is
    * always regenerated by the Form Editor.
    */

   public javax.swing.JPanel getjPMesa(){
   
   return this.jPMesa;
   
   
   }
   
   @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPMesa = new Mesa(this, this.baralho);
        jPLateral = new javax.swing.JPanel();
        jBEmbaralhar = new javax.swing.JButton();
        jBVirarCartas = new javax.swing.JButton();
        jBEnviarCarta = new javax.swing.JButton();
        jTFTCartaEnv = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jTFJogador1 = new javax.swing.JTextField();
        jTFJogador2 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jTFPontosJ1 = new javax.swing.JTextField();
        jTFPontoJ2 = new javax.swing.JTextField();
        jBTruco = new javax.swing.JButton();
        jBTSairRodada = new javax.swing.JButton();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jTFPontosRJ1 = new javax.swing.JTextField();
        jTFPontoRJ2 = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jTFMinhasCartas = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jTFManilha = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jTFCartaMesa = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jTFCartaAdv = new javax.swing.JTextField();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu3 = new javax.swing.JMenu();
        jMenu4 = new javax.swing.JMenu();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenuItem7 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem4 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("JTrucoOO - Jogo de Cartas");
        setBackground(new java.awt.Color(1, 1, 1));
        setResizable(false);

        jPMesa.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout jPMesaLayout = new javax.swing.GroupLayout(jPMesa);
        jPMesa.setLayout(jPMesaLayout);
        jPMesaLayout.setHorizontalGroup(
            jPMesaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 548, Short.MAX_VALUE)
        );
        jPMesaLayout.setVerticalGroup(
            jPMesaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 436, Short.MAX_VALUE)
        );

        jPLateral.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jBEmbaralhar.setText("Embaralhar");
        jBEmbaralhar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBEmbaralharActionPerformed(evt);
            }
        });

        jBVirarCartas.setText("Virar cartas");
        jBVirarCartas.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBVirarCartasActionPerformed(evt);
            }
        });

        jBEnviarCarta.setText("Enviar Carta");
        jBEnviarCarta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBEnviarCartaActionPerformed(evt);
            }
        });

        jLabel2.setText("Carta");

        jLabel3.setText("Você:");

        jTFJogador1.setEnabled(false);

        jTFJogador2.setEnabled(false);

        jLabel4.setText("Oponente:");

        jLabel5.setText("Pontos:");

        jLabel6.setText("Pontos:");

        jTFPontosJ1.setEnabled(false);
        jTFPontosJ1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFPontosJ1ActionPerformed(evt);
            }
        });

        jTFPontoJ2.setEnabled(false);
        jTFPontoJ2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFPontoJ2ActionPerformed(evt);
            }
        });

        jBTruco.setText("Truco");
        jBTruco.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBTrucoActionPerformed(evt);
            }
        });

        jBTSairRodada.setText("Sair da Rodada");

        jLabel7.setText("Rodada");

        jLabel8.setText("Partida");

        jTFPontosRJ1.setEnabled(false);
        jTFPontosRJ1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFPontosRJ1ActionPerformed(evt);
            }
        });

        jTFPontoRJ2.setEnabled(false);
        jTFPontoRJ2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFPontoRJ2ActionPerformed(evt);
            }
        });

        jLabel1.setText("Minhas Cartas");

        jLabel9.setText("Carta virada");

        jTFManilha.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFManilhaActionPerformed(evt);
            }
        });

        jLabel10.setText("Carta na Mesa");

        jTFCartaMesa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFCartaMesaActionPerformed(evt);
            }
        });

        jLabel11.setText("Sua");

        jLabel12.setText("Adversário");

        jTFCartaAdv.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFCartaAdvActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPLateralLayout = new javax.swing.GroupLayout(jPLateral);
        jPLateral.setLayout(jPLateralLayout);
        jPLateralLayout.setHorizontalGroup(
            jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPLateralLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jBTSairRodada, javax.swing.GroupLayout.DEFAULT_SIZE, 566, Short.MAX_VALUE)
                    .addComponent(jBTruco, javax.swing.GroupLayout.DEFAULT_SIZE, 566, Short.MAX_VALUE)
                    .addComponent(jBEmbaralhar, javax.swing.GroupLayout.DEFAULT_SIZE, 566, Short.MAX_VALUE)
                    .addComponent(jBVirarCartas, javax.swing.GroupLayout.DEFAULT_SIZE, 566, Short.MAX_VALUE)
                    .addGroup(jPLateralLayout.createSequentialGroup()
                        .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jTFTCartaEnv)
                            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jBEnviarCarta))
                    .addGroup(jPLateralLayout.createSequentialGroup()
                        .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jTFMinhasCartas, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPLateralLayout.createSequentialGroup()
                                .addGap(73, 73, 73)
                                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(jTFJogador2, javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jTFJogador1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 119, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                            .addGroup(jPLateralLayout.createSequentialGroup()
                                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPLateralLayout.createSequentialGroup()
                                        .addGap(51, 51, 51)
                                        .addComponent(jTFManilha, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(jPLateralLayout.createSequentialGroup()
                                        .addGap(38, 38, 38)
                                        .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPLateralLayout.createSequentialGroup()
                                        .addGap(68, 68, 68)
                                        .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(jPLateralLayout.createSequentialGroup()
                                        .addGap(29, 29, 29)
                                        .addComponent(jLabel11)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTFCartaMesa, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jLabel12)
                                        .addGap(18, 18, 18)
                                        .addComponent(jTFCartaAdv, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, 67, Short.MAX_VALUE)
                        .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addComponent(jTFPontosJ1, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPLateralLayout.createSequentialGroup()
                                    .addComponent(jLabel8)
                                    .addGap(38, 38, 38)))
                            .addComponent(jTFPontoJ2, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTFPontosRJ1, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTFPontoRJ2, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel7))
                        .addGap(30, 30, 30)))
                .addContainerGap())
        );
        jPLateralLayout.setVerticalGroup(
            jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPLateralLayout.createSequentialGroup()
                .addGap(45, 45, 45)
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFJogador1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3)
                    .addComponent(jTFPontosJ1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5)
                    .addComponent(jTFPontosRJ1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFJogador2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(jTFPontoJ2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6)
                    .addComponent(jTFPontoRJ2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(29, 29, 29)
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel9)
                    .addComponent(jLabel10))
                .addGap(4, 4, 4)
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFMinhasCartas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTFManilha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTFCartaMesa, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel11)
                    .addComponent(jLabel12)
                    .addComponent(jTFCartaAdv, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFTCartaEnv, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jBEnviarCarta))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 56, Short.MAX_VALUE)
                .addComponent(jBTruco)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBTSairRodada)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBVirarCartas)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBEmbaralhar)
                .addContainerGap())
        );

        jMenu3.setText("Jogo");

        jMenu4.setText("Criar Jogo");

        jMenuItem3.setText("Jogar com o Computador");
        jMenu4.add(jMenuItem3);

        jMenuItem5.setText("Jogar na rede");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem5);

        jMenuItem8.setText("Jogar na Rede e servir o Jogo");
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem8);

        jMenu3.add(jMenu4);

        jMenuItem7.setText("Sair do Jogo");
        jMenu3.add(jMenuItem7);

        jMenuBar1.add(jMenu3);

        jMenu2.setText("Ajuda");

        jMenuItem1.setText("Manual");
        jMenu2.add(jMenuItem1);

        jMenuItem2.setText("Sobre");
        jMenu2.add(jMenuItem2);

        jMenuBar1.add(jMenu2);

        jMenu1.setText("Sistema");

        jMenuItem4.setText("Sair");
        jMenu1.add(jMenuItem4);

        jMenuBar1.add(jMenu1);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPMesa, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPLateral, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPMesa, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPLateral, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

   public void SetMinhasCartas(String c){
   this.jTFMinhasCartas.setText(c);
   }
           
  public void SetManilha(String m){
   this.jTFManilha.setText(m);
   }     
   
  public void SetCartaMesa(String cm){
  
  this.jTFCartaMesa.setText(cm);
  
          }
  public void setjBEnviarCarta(boolean b){
  
      this.jBEnviarCarta.setEnabled(b);
  
  }
   private void jBEmbaralharActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBEmbaralharActionPerformed
      ((Mesa) this.jPMesa).embaralhar();
   }//GEN-LAST:event_jBEmbaralharActionPerformed

   private void jBVirarCartasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBVirarCartasActionPerformed
      ((Mesa) this.jPMesa).virarCartas();
   }//GEN-LAST:event_jBVirarCartasActionPerformed

   public void adicionarLinha(String msg){

    }
   public ClienteThread getCT(){
   return this.ct;
   
   }

   private void jBEnviarCartaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBEnviarCartaActionPerformed
       // TODO add your handling code here:
        ct.enviarMensagem("400",jTFTCartaEnv.getText());

   }//GEN-LAST:event_jBEnviarCartaActionPerformed

   public String GetTextjTFTexto(){

     return jTFTCartaEnv.getText();

   }
   
   public void SetjTFCartaAdv(String b){
   
   this.jTFCartaAdv.setText(b);
   
   }

   public String getclID(){
    return this.clID;
   
   }
       public void setTextTFTexto(String n){

   this.jTFTCartaEnv.setText(n);
   }

   public void requestFocusjTFTexto(){

       jTFTCartaEnv.requestFocus();

   }
   private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
       // TODO add your handling code here:
       this.NomeDoJogador = JOptionPane.showInputDialog("Digite o nome do jogador");
       this.jTFJogador1.setText(NomeDoJogador);
       jTFPontosJ1.setText("0");
       jTFPontoRJ2.setText("0");
       jTFPontosRJ1.setText("0");
       jTFPontoJ2.setText("0");
       ip=JOptionPane.showInputDialog("Digite o IP do servidor");
       port = JOptionPane.showInputDialog("Digite a porta do servidor");
      // sr.SocketCliente(ip,port);
       ct = new ClienteThread(this, ip, port);
       ct.start();
       

       



   }//GEN-LAST:event_jMenuItem5ActionPerformed



   public void SetjTFNomeEnabled(boolean a){

   }

   public void SetTextjBConectar(String a){

   }

   private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
       // TODO add your handling code here:
              //criando servidor
             // sr = new Servidor(this,JOptionPane.showInputDialog("Digite o nome do jogador"));
             // sr.start();


              //Criando socket cliente
              //sr.SocketCliente("127.0.0.1","1234");
   }//GEN-LAST:event_jMenuItem6ActionPerformed

   private void jTFPontosJ1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFPontosJ1ActionPerformed
       // TODO add your handling code here:
   }//GEN-LAST:event_jTFPontosJ1ActionPerformed

   private void jTFPontoJ2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFPontoJ2ActionPerformed
       // TODO add your handling code here:
   }//GEN-LAST:event_jTFPontoJ2ActionPerformed

   public void SetjTFJogador2(String a){
   this.jTFJogador2.setText(a);
   }
   private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
       // TODO add your handling code here:
              //criando servidor
             
              NomeDoJogador = JOptionPane.showInputDialog("Digite o nome do jogador");
              sr = new Servidor(this, NomeDoJogador);
              jTFJogador1.setText(NomeDoJogador);
              jTFPontosJ1.setText("0");
              jTFPontoRJ2.setText("0");
              jTFPontosRJ1.setText("0");
              jTFPontoJ2.setText("0");
              
              //Dispara o server socket
              sr.start();     
              //Criando socket cliente
              ct = new ClienteThread(this,"127.0.0.1", "1234");
              ct.start();
              //sr.SocketCliente("127.0.0.1","1234");
   }//GEN-LAST:event_jMenuItem8ActionPerformed

   private void jBTrucoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBTrucoActionPerformed
       // TODO add your handling code here:
       ct.enviarMensagem("500", null);
   }//GEN-LAST:event_jBTrucoActionPerformed

   private void jTFPontosRJ1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFPontosRJ1ActionPerformed
       // TODO add your handling code here:
   }//GEN-LAST:event_jTFPontosRJ1ActionPerformed

   private void jTFPontoRJ2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFPontoRJ2ActionPerformed
       // TODO add your handling code here:
   }//GEN-LAST:event_jTFPontoRJ2ActionPerformed

   private void jTFManilhaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFManilhaActionPerformed
       // TODO add your handling code here:
   }//GEN-LAST:event_jTFManilhaActionPerformed

   private void jTFCartaMesaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFCartaMesaActionPerformed
       // TODO add your handling code here:
   }//GEN-LAST:event_jTFCartaMesaActionPerformed

   private void jTFCartaAdvActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFCartaAdvActionPerformed
       // TODO add your handling code here:
   }//GEN-LAST:event_jTFCartaAdvActionPerformed
   public void SetjTFJogador1(String nome){

       this.jTFJogador1.setName(nome);
   
   }


      public void SetjTFPontosJ1(int p){

       this.jTFPontosJ1.setText(Integer.toString(p));
   
   }

public String getNomeJogador(){

    return this.NomeDoJogador;

}
   
   /**
    * @param args the command line arguments
    */
   public static void main(String args[]) {
      java.awt.EventQueue.invokeLater(new Runnable() {

         @Override
         public void run() {
            new Cliente().setVisible(true);
         }
      });
   }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBEmbaralhar;
    private javax.swing.JButton jBEnviarCarta;
    private javax.swing.JButton jBTSairRodada;
    private javax.swing.JButton jBTruco;
    private javax.swing.JButton jBVirarCartas;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem7;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JPanel jPLateral;
    private javax.swing.JPanel jPMesa;
    private javax.swing.JTextField jTFCartaAdv;
    private javax.swing.JTextField jTFCartaMesa;
    private javax.swing.JTextField jTFJogador1;
    private javax.swing.JTextField jTFJogador2;
    private javax.swing.JTextField jTFManilha;
    private javax.swing.JTextField jTFMinhasCartas;
    private javax.swing.JTextField jTFPontoJ2;
    private javax.swing.JTextField jTFPontoRJ2;
    private javax.swing.JTextField jTFPontosJ1;
    private javax.swing.JTextField jTFPontosRJ1;
    private javax.swing.JTextField jTFTCartaEnv;
    // End of variables declaration//GEN-END:variables
}

