package jogo;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.ArrayList;
import javax.swing.JOptionPane;

public class ClienteThread extends Thread {

    private Cliente pai;
    private ObjectOutputStream saida;
    private ObjectInputStream entrada;
    private int idmsg;
    private int myid;
    private int cod;
    private int pontos=0;
    private int Rodada=0;
    private String body;
    //private String nome;
    private Boolean mensagemrecebida = false;
    private String IPSERVIDOR;
    private String PortaServer;
    private Mensagem cmsgout;
    private Mensagem cmsgin;
    private String NomeJogador;
    private ArrayList<String> cartas = new ArrayList<String>() ;

    ClienteThread(Cliente aThis, String ip, String porta) {
        this.pai = aThis;
        this.PortaServer = porta;
        this.IPSERVIDOR = ip;
    }

    public void enviarMensagem(String a, String b) {

       // for(String cartaEnv: this.cartas){
        
           // if(cartaEnv.equals(b)){
               try {
                     saida.writeObject(cmsgout = new Mensagem(a,b));
                     pai.setjBEnviarCarta(false);
                     pai.SetCartaMesa(b);
                     } catch (IOException ex) {
                     System.err.println("Erro ao enviar msg: " + ex.toString());
                    }
           // }else{
            //     JOptionPane.showMessageDialog(this.pai,"Carta não existente na sua mão: "+b+", escolha outra");
        //
        //}
    }
      

    @Override
    public void run() {
        Socket conexao;


        try {
            conexao = new Socket(IPSERVIDOR, Integer.parseInt(PortaServer) );
            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());



            boolean conectado = true;
            saida.writeObject(new Mensagem ("100",pai.getNomeJogador()));

            while (conectado) {
                cmsgin = (Mensagem) entrada.readObject();
                //idmsg = Integer.parseInt(cmsgin.getOrgID());
                this.cod = Integer.parseInt(cmsgin.getCodigo());
                this.body = cmsgin.getCorpo();

                
                switch(this.cod)
                {
                

                    case 101:  //Recebe nome do jogador adversário
                                System.out.println("Jogador:"+ pai.getNomeJogador()+ " Cod:" + cod+ " Corpo: "+body);
                                JOptionPane.showMessageDialog(this.pai,"O jogador: "+this.body+" entrou no jogo");
                                this.pai.SetjTFJogador2(body);
                                //Pede as cartas para inicio da rodada
                                saida.writeObject(new Mensagem("200", ""));
                                saida.flush();
                                break;
                    case 201:   //recebe as cartas
                                //this.body.
                                System.out.println("Jogador:"+ pai.getNomeJogador()+ " Cod:" + cod+ " Corpo: "+body);
                                pai.SetMinhasCartas(body.substring(0,6));
                                pai.SetManilha(body.substring(6, 8));
                                cartas.add(body.substring(0,2));
                                cartas.add(body.substring(2,4));
                                cartas.add(body.substring(4,6));
                                cartas.add(body.substring(6,8));
                                pai.criaBaralho(cartas);
                                pai.getjPMesa().repaint();
                                saida.writeObject(new Mensagem("300", ""));
                                //saida.flush();
                                break;
                    case 301:  //Mão do jogo é do jogador X 
                                System.out.println("Jogador-> "+pai.getNomeJogador()+" Corpo: "+body);
                                if(body.equals("true")){
                                    pai.setMinhaVez(true);
                                    if(this.Rodada != 3){
                                    this.Rodada++;
                                    }
                                    JOptionPane.showMessageDialog(pai,"Você inicia o jogo, jogue uma carta!");
                                    pai.setjBEnviarCarta(true);
                                    
                                } else {
                                    pai.setMinhaVez(false);
                                    this.Rodada++;
                                    JOptionPane.showMessageDialog(pai,"O outro jogador inicia o jogo!");
                                }
                                //entrada.reset();
                               break;
                    case 401: //Quem levou a mão
                        
                                break;
                    case 500: //truco
                               
                               JOptionPane.showMessageDialog(pai,"COD: "+cod);
                                //entrada.reset();
                                saida.flush();
                               break;
                    case 501: //truco aceito
                               JOptionPane.showMessageDialog(pai,"COD: "+cod);
                                //entrada.reset();
                                saida.flush();
                                break;
                    case 502:   //fugir do truco
                                JOptionPane.showMessageDialog(pai,"COD: "+cod);
                                break;
                    /*case 400: //Resultado do jogo
                                JOptionPane.showMessageDialog(pai,"COD: "+cod);
                                break;*/
                        
                    case 402: //Recebe carta jogada enviadapelo Jogador Atual
                                pai.CriaCarta(body);
                                pai.getjPMesa().repaint();
                                pai.setMinhaVez(true);
                                this.Rodada++;
                                
                                
                                JOptionPane.showMessageDialog(pai,"É a sua vez de jogar!");
                    case 403: //Recebe carta jogada pelo outro jogador
                                pai.CriaCarta(body);
                                pai.getjPMesa().repaint();
                                //Pergunta quem ganhou o jogo
                                saida.writeObject(new Mensagem("500", ""));
                                //pai.setjBEnviarCarta(true);
                                //JOptionPane.showMessageDialog(pai,"É a sua vez de jogar!");
                                
                                
                                break;
                    case 600: //vencedor da jogada
                                JOptionPane.showMessageDialog(pai,"Você ganhou!");
                                pai.ApagarCarta();
                                if(this.Rodada == 2){
                                this.pontos = pontos + Integer.parseInt(body); 
                                pai.SetjTFPontosJ1(pontos);
                                saida.writeObject(new Mensagem("200", ""));
                                this.Rodada=0;
                               }
                                pai.setjBEnviarCarta(true);
                                sleep(80);
                                //saida.writeObject(new Mensagem("300", ""));
                                break;
                    case 601: //Empate da jogada
                                JOptionPane.showMessageDialog(pai,"Empatou!");
                                sleep(80);
                                //saida.writeObject(new Mensagem("300", ""));
                                break;
                    case 602: //Perdedor da jogada
                                sleep(80);
                                 if(this.Rodada == 2){
                                this.pontos = pontos + Integer.parseInt(body); 
                                pai.SetjTFPontosJ1(pontos);
                                saida.writeObject(new Mensagem("200", ""));
                                this.Rodada=0;
                               }
                                JOptionPane.showMessageDialog(pai,"Você perdeu!");
                                //saida.writeObject(new Mensagem("300", ""));
                                pai.SetjTFCartaAdv("");
                                pai.SetCartaMesa("");
                                
                                break;
                        
                     case 700: //Final de rodada
                         
                            saida.writeObject(new Mensagem("200", ""));
                            break;
                }
                
            }

            // fechando os fluxos e a conexao
            saida.close();
            entrada.close();
            conexao.close();
        } catch (Exception ex) {
            System.err.println("Erro sockets: " + ex.toString());
        }





    }
}
